// dBpaPropBug.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


int _tmain(int argc, _TCHAR* argv[])
{
	if (argc != 2)
	{
		wprintf(L"Give mp3 file path as argument.\n");
		return 0;
	}

	const wchar_t *szFile = argv[1];

	OleInitialize(NULL);

	wprintf(L"File \"%s\"\n", szFile);

	{
		HRESULT hr = S_OK;

		IShellItem2* pItem;
		if (!SUCCEEDED(hr = SHCreateItemFromParsingName(szFile, 0, IID_IShellItem2, (void**)&pItem)))
		{
			wprintf(L"SHCreateItemFromParsingName 1 fail: %lx\n", hr);
		}
		else
		{
			IPropertyStore* pStore;
			if (!SUCCEEDED(hr = pItem->GetPropertyStore(GPS_READWRITE, IID_IPropertyStore, (void**)&pStore)))
			{
				wprintf(L"GetPropertyStore 1 fail: %lx\n", hr);
			}
			else
			{
				PROPERTYKEY pk;
				pk.fmtid = FMTID_SummaryInformation;
				pk.pid   = PIDSI_KEYWORDS;

				const wchar_t *aszTagValues[] = { L"Tag1" };

				PROPVARIANT propvar;
				InitPropVariantFromStringVector(aszTagValues, _countof(aszTagValues), &propvar);

				// On a vanilla Windows 7 install, this SetValue call returns STG_E_ACCESSDENIED for MP3 files.
				// With dBpoweramp, it succeeds. (Note: On x64, dBpoweramp only interferes if the exe is compiled as x64.)
				if (!SUCCEEDED(hr = pStore->SetValue(pk, propvar)))
				{
					wprintf(L"SetValue 1 fail: %lx\n", hr);
				}
				else
				{
					if (!SUCCEEDED(hr = PropVariantClear(&propvar)))
					{
						wprintf(L"PropVariantClear 1a fail: %lx\n", hr);
					}

					if (!SUCCEEDED(hr = pStore->GetValue(pk, &propvar)))
					{
						wprintf(L"GetValue 1 fail: %lx\n", hr);
					}
					else
					{
						wprintf(L"GetValue 1 type: %d\n", static_cast< int >(propvar.vt));
					}

					if (!SUCCEEDED(hr = pStore->Commit()))
					{
						wprintf(L"Commit 1 fail: %lx\n, hr");
					}
				}

				if (!SUCCEEDED(hr = PropVariantClear(&propvar)))
				{
					wprintf(L"PropVariantClear 1b fail: %lx\n", hr);
				}

				pStore->Release();
			}

			pItem->Release();
		}
	}

	{
		HRESULT hr = S_OK;

		IShellItem2* pItem;
		if (!SUCCEEDED(hr = SHCreateItemFromParsingName(szFile, 0, IID_IShellItem2, (void**)&pItem)))
		{
			wprintf(L"SHCreateItemFromParsingName 2 fail: %lx\n", hr);
		}
		else
		{
			IPropertyStore* pStore;
			if (!SUCCEEDED(hr = pItem->GetPropertyStore(GPS_DEFAULT, IID_IPropertyStore, (void**)&pStore)))
			{
				wprintf(L"GetPropertyStore 2 fail: %lx\n", hr);
			}
			else
			{
				PROPERTYKEY pk;
				pk.fmtid = FMTID_SummaryInformation;
				pk.pid   = PIDSI_KEYWORDS;

				PROPVARIANT propvar;
				PropVariantInit(&propvar);
				
				if (!SUCCEEDED(hr = pStore->GetValue(pk, &propvar)))
				{
					wprintf(L"GetValue 2 fail: %lx\n", hr);
				}
				else
				{
					wprintf(L"GetValue 2 type: %d\n", static_cast< int >(propvar.vt));
				}

				if (!SUCCEEDED(hr = PropVariantClear(&propvar)))
				{
					wprintf(L"PropVariantClear 2 fail: %lx\n", hr);
				}

				pStore->Release();
			}

			pItem->Release();
		}
	}

	OleUninitialize();

	return 0;
}

